package spinfo.textadventure;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import spinfo.textadventure.data.Place;
import spinfo.textadventure.data.Player;
import spinfo.textadventure.data.World;
import spinfo.textadventure.io.IO;
import spinfo.textadventure.utils.Readers;

public class MyIO implements IO {

	private Readers reader = new Readers();

	@Override
	public List<Place> loadPlaces() throws InvalidGameException {
		List<Place> places = new ArrayList<Place>();
		try {
			List<String> fileContentList = reader.fileToStringList("games/adventure/places.config");

			String name = "";
			String action = "";
			List<String> addConditions = new ArrayList<String>();
			List<String> inConditions = new ArrayList<String>();
			List<String> removeConditions = new ArrayList<String>();
			String game = "";

			for (int i = 0; i < fileContentList.size(); i++) {
				String line = fileContentList.get(i);
				if (line.startsWith("name=")) {
					action = "";
					addConditions = new ArrayList<String>();
					inConditions = new ArrayList<String>();
					removeConditions = new ArrayList<String>();
					name = line.replaceFirst("name=", "");
				}
				if (line.startsWith("add_conditions=")) {
					String[] conditionsarray = line.replaceFirst("add_conditions=", "").split(",");
					// addConditions = Arrays.asList(conditionsarray);
					for (String entry : conditionsarray) {
						addConditions.add(entry);
					}
				}
				if (line.startsWith("in_conditions=")) {
					String[] inConditionsarray = line.replaceFirst("in_conditions=", "").split(",");
					// addConditions = Arrays.asList(conditionsarray);
					for (String entry : inConditionsarray) {
						inConditions.add(entry);
					}
				}
				if (line.startsWith("remove_conditions=")) {
					String[] removeConditionsarray = line.replaceFirst("remove_conditions=", "").split(",");
					// addConditions = Arrays.asList(conditionsarray);
					for (String entry : removeConditionsarray) {
						removeConditions.add(entry);
					}
				}
				if (line.isEmpty() || fileContentList.size() - 1 == i) {
					Place p = new MyPlace();
					p.setName(name);
					p.setAction(action);
					p.setAddConditions(addConditions);
					p.setInConditions(inConditions);
					p.setRemoveConditions(removeConditions);
					places.add(p);
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
//		for (Place p : places) {
//			System.out.println(p.getName());
//			System.out.println(p.getInConditions());
//		}
		return places;
	}

	@Override
	public World loadWorld(List<Place> loadedPlaces) throws InvalidGameException, FileNotFoundException {
		World world = new MyWorld();
		
		
		List<String> worldLineByLine = reader.fileToStringList("games/adventure/world.config");
		String worldPlaces;
		
		Place[][] places = new Place[worldLineByLine.size()][worldLineByLine.get(0).split("\\|").length];
		for (int j = 0; j < worldLineByLine.size(); j++) {
			worldPlaces = worldLineByLine.get(j);
			
			String[] worldArray = worldPlaces.split("\\|");

			for (int i = 0; i < worldArray.length; i++) {
				for (Place p : loadedPlaces) {
					if (p.getName().equals(worldArray[i].trim())) {
						places[j][i] = p;
						break;
					}
				}
				if (worldArray[i].trim().equals("----")) {
					Place noPlace = new MyPlace();
					noPlace.setName("----");
					List<String> inConditions = new ArrayList<String>();
					inConditions.add("YouShallNotPass!!!");
					noPlace.setInConditions(inConditions);
					places[j][i] = noPlace;
				}
			}
		}
		world.setPlaces(places);
		return world;
	}

	@Override
	public void saveGame(Player player) throws IOException {
	}

	@Override
	public Player loadGame(boolean loadSaveGame) throws IOException {

		return null;
	}

	@Override
	public void setGameDirectory(File gameDirectory) {
	}

}
